﻿//Immediate to-do list:
//Add a function to get tag data from a Ref
//Utilize submeshes to draw faces



//NOTE: Just in case: bones start at 0x70. (count, tag index, unneeded 32bits). ENOB tag. Each bone is 0xA0 long. unwanted 32bit, then name length, then tag index of name. Ref_Center, Ref_Overhead, etc. After name tag index, skip 8 bytes, write 0xFF, 0x00, Animref struct (8 bytes), X,Y,Z floats of attach point. Don't think the rest matters for attach points.
//TODO: Enable adding and editing of attach points. (They reference bones, so you need to do those too.)
//TODO: Enable adding and removing vertices, which requires implementing faces as well. Because we have that, put in a DirectX face-drawing mode.
//TODO: Enable editing of materials, especially their names.
/*
STC_stc[*].animid.u32[*]... may be offsets of vertices to modify. See 0xF19BD2 in file if it exists.
	  .animoffs.    ... not sure. aindex and sdindex?
Trans.sd3v[*].animdata.data.v3d[*] appears to be the physical offsets to modify the vertices with. You know, translate.
mSTG seems to be just an excessive way of giving each an index... uh, okay.
mSTS: who knows? Like STC IIRC.

(mDIV) DIV_ tag references: Every set of 3 shorts is a face. (Each short is the index of a vertex.)
mMatLU: material types and indexes
mat[*].layers.layr: finally! This is where the textures' names are stored. You could just find RYAL in the tags to rename the layers.
*/

using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace SimpleM3VertexManipulator
{
    public partial class Form1 : Form
    {
        DateTime lastDate = new DateTime(2012, 2, 2);

        float[] fileBuffer;
        const float heightFactor = 2.0f;
        string theFile;
        uint selectedBufferLoc;
        uint firstVertex, vertexCountTimesEight, floatsPerVertex;
        uint currModelFlags;

        string curDir;
        ComboBox[] cbBox = new ComboBox[8];
        int lastSelectedAnim = -1, lastSelectedMat = -1;
        bool ignoreCbBoxChange = false;
        bool materialsSaving = false, animsSaving = false;

        //Editor IDs
        private const int VERTICES = 1, ANIMATIONS = 2, REFPOINTS = 3, MATERIALS = 4;

        //Graphics declares
        Device dxDev = null;
        VertexBuffer vBuff = null;
        bool keepTicking = true;

        //Rotation and stuff
        float XR, YR, ZR, offX, offY, backAmnt, blinker;
        float startingXR, startingYR, startingZR, startingOffX, startingOffY, startingBackAmnt;
        bool moddingRotation = false;
        Point startingCursorPos, actualStartingCursorPos;
        int gFaceCount;

        //Options
        bool autoRotateChecked = true, drawXYZChecked = false, renderFacesChecked = false;

        public Form1()
        {
            InitializeComponent();
            backAmnt = 6;
            curDir = Application.ExecutablePath;
        }

        private void Form1_Closing(object sender, EventArgs e)
        {
            KillGL();
        }

        private void enableAllControls(Control.ControlCollection cc, bool tEnable)
        {
            foreach (Control c in cc)
            {
                c.Enabled = tEnable;
                if (c.HasChildren)
                {
                    enableAllControls(c.Controls, tEnable);
                }
            }
        }

        private void startWork(string txt)
        {
            enableAllControls(Controls, false);
            for (int x = 0; x < menuStrip1.Items.Count; x++) menuStrip1.Items[x].Enabled = false;
            statusBar.Text = txt;
            Application.DoEvents();
        }

        private void endWork(string txt)
        {
            enableAllControls(Controls, true);
            for (int x = 0; x < menuStrip1.Items.Count; x++) menuStrip1.Items[x].Enabled = true;
            statusBar.Text = txt;
            Application.DoEvents();
        }

        private void createList()
        {
            int tIdx;
            uint X, Z;
            floatsPerVertex = 8;

            //Get tags' offset
            uint startOffset = FromFloat(fileBuffer[1]) / 4;

            for (X = startOffset; X < fileBuffer.Length; X += 4) //All tags are 32 bytes, so X += 4 (times 4 bytes per float)
            {
                if (fileBuffer[X] == 1.26699847e+13f) //1429757791 as an int //Find "__8U", which is the vertex tag's ID
                {
                    //Seek to first vertex
                    firstVertex = (uint)(FromFloat(fileBuffer[X + 1]) / 4);

                    if (FromFloat(fileBuffer[0]) == 1296315188) //"43DM" header (MODL_TYPE = 34)
                    {
                        //bitFlags is at 0x80, or index 32
                        currModelFlags = FromFloat(fileBuffer[32]);
                    }
                    else
                    {
                        //bitFlags is at 0x78, or index 30
                        currModelFlags = FromFloat(fileBuffer[30]);
                    }
                    if ((currModelFlags & 0x200) != 0) floatsPerVertex += 1;
                    if ((currModelFlags & 0x40000) != 0) floatsPerVertex += 1;
                    if ((currModelFlags & 0x80000) != 0) floatsPerVertex += 1;
                    if ((currModelFlags & 0x100000) != 0) floatsPerVertex += 1;

                    vertexCountTimesEight = (uint)(FromFloat(fileBuffer[X + 2]) / (4 * floatsPerVertex)) * floatsPerVertex;

                    lstVertices.BeginUpdate();
                    lstVertices.Items.Clear();
                    selectedBufferLoc = 0;

                    for (Z = firstVertex; Z < firstVertex + vertexCountTimesEight; Z += floatsPerVertex)
                    {
                        tIdx = getListPos(fileBuffer[Z], fileBuffer[Z + 1], fileBuffer[Z + 2]);
                        uintTagListItem tItem = new uintTagListItem(Z, getCoordString(Z), getCoordString(Z + 1), getCoordString(Z + 2));
                        if (tIdx != -1) lstVertices.Items.Insert(tIdx, (ListViewItem)tItem);
                        else lstVertices.Items.Add((ListViewItem)tItem);
                    }
                    lstVertices.EndUpdate();
                    return;
                }
            }
        }

        private int getListPos(float x, float y, float z)
        {
            //Sorts the vertices radially on the XY plane
            //TODO: do that. Right now, it's just sorted by Z.

            for (int w = 0; w < lstVertices.Items.Count; w++)
            {
                if (fileBuffer[((uintTagListItem)lstVertices.Items[w]).buffLocTag + 2] > z)
                {
                    return w;
                }
            }

            return -1;
        }

        private unsafe float ToFloat(uint longBits)
        {
            float* singleBits;
            singleBits = (float*)&longBits;
            return *singleBits; //Note: can use float.IsNaN(*singleBits) to determine if this is a bad value
        }

        private unsafe uint FromFloat(float singleBits)
        {
            uint* longBits;
            longBits = (uint*)&singleBits;
            return *longBits;
        }

        void commitAllChanges()
        {
            saveAnim();
            saveMaterials();
        }

        void splitContainer1_SplitterMoved(object sender, System.Windows.Forms.SplitterEventArgs e)
        {
            lstVertices.BeginUpdate();
            lstVertices.Size = new System.Drawing.Size(splitContainer1.Panel1.Width - 2, splitContainer1.Panel1.Height - 2);
            lstAnimNames.Size = lstVertices.Size;

            lstVertices.Columns[0].Width = lstVertices.ClientSize.Width / 3;
            lstVertices.Columns[1].Width = lstVertices.ClientSize.Width / 3;
            lstVertices.Columns[2].Width = lstVertices.ClientSize.Width / 3;
            lstVertices.EndUpdate();

            pictureBox1.Size = new System.Drawing.Size(splitContainer1.Panel2.Width - 2, splitContainer1.Panel2.Height - 2);
        }

        private void Form1_Resize(object sender, System.EventArgs e)
        {
            if (ClientRectangle.Width > splitContainer1.Left + 402)
            {
                splitContainer1.Width = ClientRectangle.Width - splitContainer1.Left - 2;
            }
            else
            {
                splitContainer1.Width = 400;
            }

            if (ClientRectangle.Height > splitContainer1.Top + 224)
            {
                splitContainer1.Height = ClientRectangle.Height - splitContainer1.Top - 24;
            }
            else
            {
                splitContainer1.Height = 200;
            }

            splitContainer1_SplitterMoved(sender, null);
        }

        void lstVertices_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            nanoTimer.Enabled = false;
            nanoTimer.Enabled = true;
        }

        private void nanoTimer_Tick(object sender, EventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 0)
            {
                selectedBufferLoc = ((uintTagListItem)lstVertices.Items[lstVertices.SelectedIndices[0]]).buffLocTag;
                txtXVal.Text = getCoordString(selectedBufferLoc);
                txtYVal.Text = getCoordString(selectedBufferLoc + 1);
                txtZVal.Text = getCoordString(selectedBufferLoc + 2);

                if ((currModelFlags & 0x200) != 0)
                {
                    txtUVal.Text = ((float)(FromFloat(fileBuffer[selectedBufferLoc + 7]) & 0x0000FFFF) / 2048f).ToString();
                    txtVVal.Text = ((float)((FromFloat(fileBuffer[selectedBufferLoc + 7]) & 0xFFFF0000) / 0x10000) / 2048f).ToString();
                }
                else
                {
                    txtUVal.Text = ((float)(FromFloat(fileBuffer[selectedBufferLoc + 6]) & 0x0000FFFF) / 2048f).ToString();
                    txtVVal.Text = ((float)((FromFloat(fileBuffer[selectedBufferLoc + 6]) & 0xFFFF0000) / 0x10000) / 2048f).ToString();
                }
            }
            nanoTimer.Enabled = false;
        }

        public string getCoordString(uint bl)
        {
            return fileBuffer[bl].ToString();
        }

        void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            moddingRotation = true;
            startingCursorPos = Cursor.Position; //This one is modified if you reach the edge of the screen
            actualStartingCursorPos = Cursor.Position; //This one is not modified
            startingXR = XR;
            startingYR = YR;
            startingZR = ZR;
            startingOffX = offX;
            startingOffY = offY;
            startingBackAmnt = backAmnt;
            Cursor.Hide();
        }

        void pictureBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            moddingRotation = false;
            Cursor.Position = actualStartingCursorPos;
            Cursor.Show();
        }

        void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                offX = startingOffX + (float)(Cursor.Position.X - startingCursorPos.X) / 800f;
                offY = startingOffY - (float)(Cursor.Position.Y - startingCursorPos.Y) / 800f;
            }
            else if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                XR = startingXR + (float)(Cursor.Position.X - startingCursorPos.X) / 500f;
                YR = startingYR + (float)(Cursor.Position.Y - startingCursorPos.Y) / 500f;
            }
            else if (e.Button == System.Windows.Forms.MouseButtons.Middle)
            {
                backAmnt = startingBackAmnt + (float)(Cursor.Position.Y - startingCursorPos.Y) / 500f;
            }
            else
            {
                return;
            }

            //TODO: instead of being whole-screen, this should be based only on the picturebox. Otherwise, it ends up opening context menus and junk.
            Screen currScreen = Screen.FromPoint(MousePosition);
            if (MousePosition.X > currScreen.Bounds.Right - 10)
            {
                Cursor.Position = new Point(currScreen.Bounds.Left + 10, Cursor.Position.Y);
                startingCursorPos.X -= currScreen.Bounds.Width;
            }
            if (MousePosition.X < currScreen.Bounds.Left + 10)
            {
                Cursor.Position = new Point(currScreen.Bounds.Right - 10, Cursor.Position.Y);
                startingCursorPos.X += currScreen.Bounds.Width;
            }
            if (MousePosition.Y > currScreen.Bounds.Bottom - 10)
            {
                Cursor.Position = new Point(Cursor.Position.X, currScreen.Bounds.Top + 10);
                startingCursorPos.Y -= currScreen.Bounds.Height;
            }
            if (MousePosition.Y < currScreen.Bounds.Top + 10)
            {
                Cursor.Position = new Point(Cursor.Position.X, currScreen.Bounds.Bottom - 10);
                startingCursorPos.Y += currScreen.Bounds.Height;
            }
        }


        void txtXVal_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 1) return;

            try
            {
                if (txtXVal.Text == "") txtXVal.Text = "0";
                fileBuffer[selectedBufferLoc] = float.Parse(txtXVal.Text);
            }
            catch (Exception)
            {
                e.Cancel = true;
            }

            try
            {
                lstVertices.SelectedItems[0].SubItems[0].Text = getCoordString(selectedBufferLoc);
                lstVertices.SelectedItems[0].SubItems[1].Text = getCoordString(selectedBufferLoc + 1);
                lstVertices.SelectedItems[0].SubItems[2].Text = getCoordString(selectedBufferLoc + 2);
                setupVBuff(dxDev);
            }
            catch (Exception)
            {
                //Don't care.
            }
        }

        void txtYVal_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 1) return;

            try
            {
                if (txtYVal.Text == "") txtYVal.Text = "0";
                fileBuffer[selectedBufferLoc + 1] = float.Parse(txtYVal.Text);
            }
            catch (Exception)
            {
                e.Cancel = true;
            }

            try
            {
                lstVertices.SelectedItems[0].SubItems[0].Text = getCoordString(selectedBufferLoc);
                lstVertices.SelectedItems[0].SubItems[1].Text = getCoordString(selectedBufferLoc + 1);
                lstVertices.SelectedItems[0].SubItems[2].Text = getCoordString(selectedBufferLoc + 2);
                setupVBuff(dxDev);
            }
            catch (Exception)
            {
                //Don't care.
            }
        }

        void txtZVal_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 1) return;

            try
            {
                if (txtZVal.Text == "") txtZVal.Text = "0";
                fileBuffer[selectedBufferLoc + 2] = float.Parse(txtZVal.Text);
            }
            catch (Exception)
            {
                e.Cancel = true;
            }

            try
            {
                lstVertices.SelectedItems[0].SubItems[0].Text = getCoordString(selectedBufferLoc);
                lstVertices.SelectedItems[0].SubItems[1].Text = getCoordString(selectedBufferLoc + 1);
                lstVertices.SelectedItems[0].SubItems[2].Text = getCoordString(selectedBufferLoc + 2);
                setupVBuff(dxDev);
            }
            catch (Exception)
            {
                //Don't care.
            }
        }

        void txtUVal_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 1) return;

            try
            {
                if (txtUVal.Text == "") txtUVal.Text = "0";

                int iVal = (int)(float.Parse(txtUVal.Text) * 2048);
                if (iVal < 0) iVal = 0; //In case of negative values
                else if (iVal > 2047) iVal = 2047; //In case of excessively large values
                //multiply by 2048, then store in the least significant 16 bits (DCBA in file = ABCD in memory, and this is CD.)
                if ((currModelFlags & 0x200) != 0)
                {
                    fileBuffer[selectedBufferLoc + 7] = ToFloat((FromFloat(fileBuffer[selectedBufferLoc + 7]) & 0xFFFF0000) | (uint)iVal);
                }
                else
                {
                    fileBuffer[selectedBufferLoc + 6] = ToFloat((FromFloat(fileBuffer[selectedBufferLoc + 6]) & 0xFFFF0000) | (uint)iVal);
                }
            }
            catch (Exception)
            {
                e.Cancel = true;
            }

            try
            {
                setupVBuff(dxDev);
            }
            catch (Exception)
            {
                //Don't care.
            }
        }

        void txtVVal_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lstVertices.SelectedIndices.Count != 1) return;

            try
            {
                if (txtVVal.Text == "") txtVVal.Text = "0";

                int iVal = (int)(float.Parse(txtVVal.Text) * 2048);
                if (iVal < 0) iVal = 0; //In case of negative values
                else if (iVal > 2047) iVal = 2047; //In case of excessively large values
                //multiply by 2048, then store in the most significant 16 bits (DCBA in file = ABCD in memory, and this is AB.)
                if ((currModelFlags & 0x200) != 0)
                {
                    fileBuffer[selectedBufferLoc + 7] = ToFloat((FromFloat(fileBuffer[selectedBufferLoc + 7]) & 0x0000FFFF) | ((uint)iVal * 0x10000u));
                }
                else
                {
                    fileBuffer[selectedBufferLoc + 6] = ToFloat((FromFloat(fileBuffer[selectedBufferLoc + 6]) & 0x0000FFFF) | ((uint)iVal * 0x10000u));
                }
            }
            catch (Exception)
            {
                e.Cancel = true;
            }

            try
            {
                setupVBuff(dxDev);
            }
            catch (Exception)
            {
                //Don't care.
            }
        }







        //Graphics
        private void InitGL()
        {
            try
            {
                PresentParameters pParams = new PresentParameters();
                pParams.Windowed = true;
                pParams.SwapEffect = SwapEffect.Discard;
                pParams.EnableAutoDepthStencil = true; //TODO: Don't know what this is
                pParams.AutoDepthStencilFormat = DepthFormat.D16; //TODO: Don't know what this is
                pParams.PresentationInterval = PresentInterval.Immediate; //TODO: Don't know what this is
                pParams.BackBufferFormat = Format.Unknown;

                dxDev = new Device(0, DeviceType.Hardware, pictureBox1, CreateFlags.HardwareVertexProcessing, pParams);

                dxDev.DeviceReset += new System.EventHandler(this.OnResetDevice);
                OnResetDevice(dxDev, null);
            }
            catch (DirectXException)
            {
                //We seriously don't care if the graphics fail. It's not like they're important.
                return;
            }
        }

        private void setupVBuff(Device dev)
        {
            if (renderFacesChecked)
            {
                setupVBuffFaces(dev);
                return;
            }

            if (lstVertices.Items.Count == 0) return;
            vBuff = new VertexBuffer(typeof(PositionColoredPointSize), lstVertices.Items.Count, dev, 0, CustomVertex.PositionColored.Format | VertexFormats.PointSize, Pool.Default);
            GraphicsStream stm = vBuff.Lock(0, 0, 0);
            PositionColoredPointSize[] verts = new PositionColoredPointSize[lstVertices.Items.Count];

            for (int w = 0; w < lstVertices.Items.Count; w++)
            {
                verts[w].X = fileBuffer[((uintTagListItem)lstVertices.Items[w]).buffLocTag];
                verts[w].Y = fileBuffer[((uintTagListItem)lstVertices.Items[w]).buffLocTag + 1];
                verts[w].Z = fileBuffer[((uintTagListItem)lstVertices.Items[w]).buffLocTag + 2];
                verts[w].PointSize = 1f;
                verts[w].Color = System.Drawing.Color.White.ToArgb();
            }

            stm.Write(verts);
            vBuff.Unlock();
        }

        private void setupVBuffFaces(Device dev)
        {
            if (lstVertices.Items.Count == 0) return;

            //locate face info, then read it.
            int startOffset = (int)FromFloat(fileBuffer[1]) / 4;

            //Find _VID tag. (805.3495 or 1145656927)
            for (int X = startOffset; X < fileBuffer.Length; X += 4) //All tags are 32 bytes, so X += 4 (times 4 bytes per float)
            {
                if (FromFloat(fileBuffer[X]) == 0x4449565Fu) //Find "_VID" (in file, or DIV_ in memory), which is the faces tag's ID
                {
                    //Get offset of headref info
                    uint facesRefOffset = FromFloat(fileBuffer[X + 1]) / 4;
                    //Get tag index from headref; convert to offset
                    uint tagLoc = (uint)startOffset + FromFloat(fileBuffer[facesRefOffset + 1]) * 4u;

                    int facesOffset = (int)FromFloat(fileBuffer[tagLoc + 1]) / 4;
                    //This value in the file is actually 3x the face count... ie. the number of shorts.
                    //So we take this faceCount and cut it in half because 3 floats = 2 faces = 6 shorts.
                    //Thus, this value is the number of floats in which all the face data is contained.
                    int faceFloatCount = (int)(FromFloat(fileBuffer[tagLoc + 2]) + 1) / 2; //The +1 is the same as Math.Ceiling() for this.

                    gFaceCount = (int)(FromFloat(fileBuffer[tagLoc + 2]) / 3); //Actual number of faces

                    vBuff = new VertexBuffer(typeof(CustomVertex.PositionNormalColored), gFaceCount * 3, dev, 0, CustomVertex.PositionNormalColored.Format, Pool.Default);
                    GraphicsStream stm = vBuff.Lock(0, 0, 0);
                    CustomVertex.PositionNormalColored[] verts = new CustomVertex.PositionNormalColored[gFaceCount * 3]; //3 vertices per face
                    int tV = 0, vIdx;
                    uint normals;
                    float normalX, normalY, normalZ;


                    //TODO: Instead of looping through faces like this, you need to read the submesh Ref located at submeshRefOffset = FromFloat(fileBuffer[X + 4]) / 4
                    //uint tagLocSubmesh = (uint)startOffset + FromFloat(fileBuffer[submeshRefOffset + 1]) * 4u;
                    //uint submeshOffset = (int)FromFloat(fileBuffer[tagLocSubmesh + 1]) / 4;
                    //int submeshFloatCount = (int)FromFloat(fileBuffer[tagLocSubmesh + 2]);
                    //if modl type = 33, these are ushorts; otherwise, they're uints: s1, vind, vnum. After those, there's faceInd, faceNum, then bone stuff.

                    //Get vertex indices
                    for (int y = facesOffset; y < facesOffset + faceFloatCount; y++)
                    {
                        //It's backwards in the file, so... we're backwards!
                        vIdx = (int)(FromFloat(fileBuffer[y]) & 0x0000FFFFu);
                        normals = FromFloat(fileBuffer[firstVertex + floatsPerVertex * vIdx + 5]);
                        normalX = (float)((normals & 0xFF000000u) / 0x1000000u) / 255f;
                        normalY = (float)((normals & 0xFF0000u) / 0x10000u) / 255f;
                        normalZ = (float)((normals & 0xFF00u) / 0x100u) / 255f;
                        verts[tV] = new CustomVertex.PositionNormalColored(fileBuffer[firstVertex + floatsPerVertex * vIdx], fileBuffer[firstVertex + floatsPerVertex * vIdx + 1], fileBuffer[firstVertex + floatsPerVertex * vIdx + 2], normalX, normalY, normalZ, Color.White.ToArgb());
                        tV++;

                        if (tV < verts.Length)
                        {
                            vIdx = (int)((FromFloat(fileBuffer[y]) & 0xFFFF0000u) / 0x10000u);
                            normals = FromFloat(fileBuffer[firstVertex + floatsPerVertex * vIdx + 5]);
                            normalX = (float)((normals & 0xFF000000u) / 0x1000000u) / 255f;
                            normalY = (float)((normals & 0xFF0000u) / 0x10000u) / 255f;
                            normalZ = (float)((normals & 0xFF00u) / 0x100u) / 255f;
                            verts[tV] = new CustomVertex.PositionNormalColored(fileBuffer[firstVertex + floatsPerVertex * vIdx], fileBuffer[firstVertex + floatsPerVertex * vIdx + 1], fileBuffer[firstVertex + floatsPerVertex * vIdx + 2], normalX, normalY, normalZ, Color.White.ToArgb());
                        }
                        //TODO: if you want to use uv coords, flag 0x200 (according to the 010 hex editor...I think my code had to reverse it) being 1 dictates that there is an extra uint32 before the uv coords, which are two shorts that are each divided by 2048 to give a decimal value. They're at buffloc+6 if the long isn't there, or buffloc+7 if it is.
                        //TODO: The normals come before that long, at buffloc+5, as one-byte values (0xFF000000, 0xFF0000, 0xFF00) which are divided by 255 after loading, to get a decimal.
                        tV++;

                        //TODO: Error in rendering faces is caused by not using the submesh data.
                    }

                    stm.Write(verts);
                    vBuff.Unlock();
                    break;
                }
            }
        }



        public struct PositionColoredPointSize
        {
            public float X, Y, Z;
            public float PointSize;
            public int Color; // 32-bit integer
            public PositionColoredPointSize(float xpos, float ypos, float zpos, float psize, int pcolor)
            {
                X = xpos;
                Y = ypos;
                Z = zpos;
                PointSize = psize;
                Color = pcolor;
            }
            public PositionColoredPointSize(Vector3 pos, float psize, int pcolor)
            {
                X = pos.X;
                Y = pos.Y;
                Z = pos.Z;
                PointSize = psize;
                Color = pcolor;
            }
        }

        private void G_Tick()
        {
            if (dxDev == null || fileBuffer == null || lstVertices.Items.Count == 0)
                return;

            dxDev.Clear(ClearFlags.Target, Color.Black, 1.0f, 0);
            dxDev.Clear(ClearFlags.ZBuffer, Color.Black, 1.0f, 0);

            //Scene goes here
            dxDev.BeginScene();
            dxDev.Transform.Projection = Matrix.PerspectiveFovLH(0.785398f, (float)pictureBox1.ClientSize.Width / pictureBox1.ClientSize.Height, 0.1f, 100.0f);
            dxDev.RenderState.ZBufferEnable = true;

            if (renderFacesChecked)
            {
                dxDev.RenderState.Lighting = true;
                dxDev.Lights[0].Type = LightType.Directional;
                dxDev.Lights[0].Diffuse = Color.White;
                dxDev.Lights[0].Direction = new Vector3(0f, -1f, -1f);
                dxDev.Lights[0].Enabled = true;
                dxDev.RenderState.CullMode = Cull.CounterClockwise;
            }
            else
            {
                dxDev.RenderState.Lighting = false;
            }


            dxDev.Transform.View = Matrix.RotationYawPitchRoll(XR, YR, ZR) * Matrix.Translation(offX, offY, backAmnt);
            if (!moddingRotation && autoRotateChecked)
            {
                ZR += 0.05f;
            }
            if (XR > 2f * Math.PI) XR -= 2f * (float)Math.PI;
            if (YR < 0) YR += 2f * (float)Math.PI;
            if (ZR > 2f * Math.PI) ZR -= 2f * (float)Math.PI;

            if (vBuff != null) //TODO: Uncomment. This is commented out for debugging.
            {
                if (renderFacesChecked)
                {
                    dxDev.SetStreamSource(0, vBuff, 0);
                    dxDev.VertexFormat = CustomVertex.PositionNormalColored.Format;
                    dxDev.DrawPrimitives(PrimitiveType.TriangleList, 0, gFaceCount);
                }
                else
                {
                    dxDev.SetStreamSource(0, vBuff, 0);
                    dxDev.VertexFormat = CustomVertex.PositionColored.Format | VertexFormats.PointSize;
                    dxDev.DrawPrimitives(PrimitiveType.PointList, 0, lstVertices.Items.Count);
                }
            }

            dxDev.RenderState.Lighting = false;
            dxDev.RenderState.ZBufferEnable = false;
            //Blinker
            blinker += 1;
            if (blinker > 20) blinker = 0;

            if (selectedBufferLoc > 0)
            {
                PositionColoredPointSize[] verts = new PositionColoredPointSize[1];
                verts[0] = new PositionColoredPointSize(fileBuffer[selectedBufferLoc], fileBuffer[selectedBufferLoc + 1], fileBuffer[selectedBufferLoc + 2], 6f - blinker / 6, Color.LimeGreen.ToArgb());
                if (blinker > 10f) verts[0].Color = Color.Red.ToArgb();
                dxDev.DrawUserPrimitives(PrimitiveType.PointList, 1, verts);
            }

            dxDev.RenderState.ZBufferEnable = true;
            //Draw XYZ lines
            if (drawXYZChecked)
            {
                dxDev.VertexFormat = CustomVertex.PositionColored.Format;
                CustomVertex.PositionColored[] xyzLines = new CustomVertex.PositionColored[6];
                xyzLines[0] = new CustomVertex.PositionColored(0f, 0f, 0f, Color.Red.ToArgb()); //X
                xyzLines[1] = new CustomVertex.PositionColored(3f, 0f, 0f, Color.Red.ToArgb());
                xyzLines[2] = new CustomVertex.PositionColored(0f, 0f, 0f, Color.LimeGreen.ToArgb()); //Y
                xyzLines[3] = new CustomVertex.PositionColored(0f, 3f, 0f, Color.LimeGreen.ToArgb());
                xyzLines[4] = new CustomVertex.PositionColored(0f, 0f, 0f, Color.Blue.ToArgb()); //Z
                xyzLines[5] = new CustomVertex.PositionColored(0f, 0f, 3f, Color.Blue.ToArgb());
                dxDev.DrawUserPrimitives(PrimitiveType.LineList, 3, xyzLines);
            }



            dxDev.EndScene();
            dxDev.Present();
        }

        public void OnResetDevice(object sender, EventArgs e)
        {
            setupVBuff((Device)sender);
        }

        //    G.DrawSubPoints 2
        //    For X = 0 To List1.ListCount - 1
        //        G.Vertex ToFloat(fileBuffer(List1.ItemData(X))), ToFloat(fileBuffer(List1.ItemData(X) + 1)), ToFloat(fileBuffer(List1.ItemData(X) + 2))

        //        If List1.ItemData(X) = selectedBufferLoc Then 'Highlight selected vertex
        //            G.DrawSubPoints 3 + (blinker / 30)
        //            G.Vertex ToFloat(fileBuffer(List1.ItemData(X))), ToFloat(fileBuffer(List1.ItemData(X) + 1)), ToFloat(fileBuffer(List1.ItemData(X) + 2))
        //            G.EndSub

        //            G.DrawSubPoints 2
        //            G.Color 255, 255, 255, 255
        //        End If
        //    Next X
        //    G.EndSub




        private void tmrGL_Tick(object sender, EventArgs e)
        {
            tmrGL.Enabled = false;
            InitGL();

            while (keepTicking)
            {
                G_Tick();
                System.Threading.Thread.Sleep(33);
                Application.DoEvents();
            }

            keepTicking = true;
        }

        protected void KillGL()
        {
            keepTicking = false;
            if (dxDev != null) dxDev.Dispose();

            Application.Exit();
            Application.ExitThread();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int x = 0; x < 8; x++)
            {
                cbBox[x] = new ComboBox();
                cbBox[x].BeginUpdate();
                cbBox[x].DropDownStyle = cbBoxTemplate.DropDownStyle;
                cbBox[x].Location = cbBoxTemplate.Location;
                cbBox[x].Size = cbBoxTemplate.Size;
                cbBox[x].Top += x * (txtYVal.Top - txtXVal.Top);
                cbBox[x].Tag = cbBoxTemplate.Tag;
                cbBox[x].MaxDropDownItems = cbBoxTemplate.MaxDropDownItems;
                for (int y = 0; y < cbBoxTemplate.Items.Count; y++)
                {
                    cbBox[x].Items.Add(cbBoxTemplate.Items[y]);
                }
                cbBox[x].EndUpdate();
                panelAnims.Controls.Add(cbBox[x]);
                cbBox[x].Visible = false;
                cbBox[x].SelectedIndexChanged += cbBox_SelectedIndexChanged;
            }
            showEditor(VERTICES);
            panelAnims.Location = new Point(0, 27);
            panelMaterials.Location = new Point(0, 27);
            panelVertices.Location = new Point(0, 27);
            splitContainer1.Location = new Point(103, 27);
            Form1_Resize(sender, null);
        }

        private void showEditor(int editorID)
        {
            if (editorID == VERTICES)
            {
                lstVertices.Visible = true;
                panelVertices.Visible = true;
                lstVertices.Focus();
            }
            else
            {
                lstVertices.Visible = false;
                panelVertices.Visible = false;
            }

            if (editorID == MATERIALS)
            {
                lstMaterials.Visible = true;
                panelMaterials.Visible = true;
                lstVertices.Focus();
            }
            else
            {
                lstMaterials.Visible = false;
                panelMaterials.Visible = false;
            }

            if (editorID == ANIMATIONS)
            {
                lstAnimNames.Visible = true;
                panelAnims.Visible = true;
                lstAnimNames.Focus();
            }
            else
            {
                lstAnimNames.Visible = false;
                panelAnims.Visible = false;
                for (int x = 0; x < 8; x++)
                {
                    cbBox[x].Visible = false;
                }
            }
        }

        private void getAnims()
        {
            lastSelectedAnim = -1;
            if (fileBuffer == null) return;
            uint X;
            //Get tags' start offset
            uint startOffset = FromFloat(fileBuffer[1]) / 4;

            for (X = startOffset; X < fileBuffer.Length; X += 4) //All tags are 32 bytes, so X += 4 (times 4 bytes per float)
            {
                if (FromFloat(fileBuffer[X]) == 0x53455153u) //Find "SQES" (in file, or SEQS in memory), which is the sequences tag's ID
                {
                    uint animSeqStart = FromFloat(fileBuffer[X + 1]) / 4;
                    uint animSeqCount = FromFloat(fileBuffer[X + 2]);

                    lstAnimNames.BeginUpdate();
                    lstAnimNames.Items.Clear();

                    //get all anim seqs
                    for (uint Y = 0; Y < animSeqCount; Y++)
                    {
                        uint tIdx = animSeqStart + Y * 24; //0x60 (96) bytes

                        uint tagIndex = startOffset + 4 * FromFloat(fileBuffer[tIdx + 3]);
                        uint nameStringOffset = FromFloat(fileBuffer[tagIndex + 1]) / 4;

                        string tStr = "";
                        for (uint Z = 0; Z < Math.Ceiling((double)FromFloat(fileBuffer[tagIndex + 2]) / 4.0); Z++)
                        {
                            //Get string
                            tStr += (char)(FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFFu);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF00u) / 0x100u);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF0000u) / 0x10000u);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF000000u) / 0x1000000u);
                        }
                        tStr = tStr.Substring(0, tStr.IndexOf('\0'));

                        lstAnimNames.Items.Add(new animListItem(tIdx, tagIndex, nameStringOffset, tStr));
                    }

                    lstAnimNames.EndUpdate();
                }
            }
            //TODO: get animation sequences and be able to change their names.
            //0x30 in file is number of animations
            //0x34 is index of SEQS tag

            //mSEQs structure:
            //Done: look for SQES (in-file) / SEQS (in-memory) 8.4747295e+11 or 8.47472951296e+11
            //Done: get second float from there, which is offset; third byte is count
            //Done: go to [offset / 4]
            //Change 2nd float after that location to the length of the new name string (including null)
            //Done: Third float is index of tag, 1 being 32 bytes from startingOffset
            //Done: get tag with name "CHAR", one for each sequence. Each chunk is always 0x60 (aka 96) bytes.

            //Possibly have to change stuff for _CTS tag and _GTS tag too. _CTS has things like "Burrow_full" while _GTS matches SQES but at different byte offsets. Offset in _GTS tag points to first anim's name length then tag index. Each of THOSE chunks after the _GTS offset is 0x18 long.
        }

        private void saveAnim()
        {
            if (lastSelectedAnim == -1 || animsSaving) return;
            animsSaving = true;
            animListItem lss = (animListItem)lstAnimNames.Items[lastSelectedAnim];
            updateString(FromFloat(fileBuffer[lss.nameLengthIndex1 + 2]), lss.animName.Length, lss.nameLengthIndex1, lss.nameLengthIndex2, lss.animName, lss.buffLoc);
            lstAnimNames.Items.RemoveAt(lastSelectedAnim);
            lstAnimNames.Items.Insert(lastSelectedAnim, lss);
            animsSaving = false;
        }

        //Fixes all addresses in the program and file buffer both. Also reallocates the file buffer and moves the data after buffLoc.
        //buffLoc is the point where data was inserted or removed.
        //lengthDiff is how many 32-bit values to add.
        private void fixAddresses(uint buffLoc, int lengthDiff)
        {
            uint buffLoc4 = buffLoc * 4;
            int lengthDiff4 = lengthDiff * 4;

            //Fix offsets of AnimName items
            for (int x = 0; x < lstAnimNames.Items.Count; x++)
            {
                animListItem tItem = (animListItem)lstAnimNames.Items[x];
                if (tItem.buffLoc > buffLoc) tItem.buffLoc = (uint)((int)tItem.buffLoc + lengthDiff);
                if (tItem.nameLengthIndex1 > buffLoc) tItem.nameLengthIndex1 = (uint)((int)tItem.nameLengthIndex1 + lengthDiff);
                if (tItem.nameLengthIndex2 > buffLoc) tItem.nameLengthIndex2 = (uint)((int)tItem.nameLengthIndex2 + lengthDiff);
            }
            for (int x = 0; x < lstVertices.Items.Count; x++)
            {
                //Fix offsets of Vertex items
                uintTagListItem tItem = (uintTagListItem)lstVertices.Items[x];
                if (tItem.buffLocTag > buffLoc) tItem.buffLocTag = (uint)((int)tItem.buffLocTag + lengthDiff);
            }
            if (firstVertex > buffLoc) firstVertex = (uint)((int)firstVertex + lengthDiff);

            //Fix offsets of Materials
            for (int x = 0; x < lstMaterials.Items.Count; x++)
            {
                matListItem tItem = (matListItem)lstMaterials.Items[x];
                if (tItem.buffLoc > buffLoc) tItem.buffLoc = (uint)((int)tItem.buffLoc + lengthDiff);
                if (tItem.nameLengthIndex1 > buffLoc) tItem.nameLengthIndex1 = (uint)((int)tItem.nameLengthIndex1 + lengthDiff);
                if (tItem.nameLengthIndex2 > buffLoc) tItem.nameLengthIndex2 = (uint)((int)tItem.nameLengthIndex2 + lengthDiff);
            }

            int tagStartOff = (int)FromFloat(fileBuffer[1]) / 4 + 1;
            int tagEndOff = tagStartOff + (int)FromFloat(fileBuffer[2]) * 4;
            //Just loop through every chunk (using that chunk offset we got earlier), and if the second uint32 is greater than our string offset, add to it.
            for (int x = tagStartOff; x < tagEndOff; x += 4)
            {
                //Fix offsets of tags
                int tInt = (int)FromFloat(fileBuffer[x]);
                if (tInt > buffLoc4) fileBuffer[x] = ToFloat((uint)(tInt + lengthDiff4));
            }

            //Fix tag chunk offset. TODO: We're assuming for now that the first tag is *after* the data we added/removed.
            fileBuffer[1] = ToFloat((uint)((tagStartOff - 1) * 4 + lengthDiff4));

            //move all the memory after this offset
            float[] tFileBuffer2 = new float[fileBuffer.Length + lengthDiff];
            for (int x = 0; x < buffLoc; x++)
            {
                tFileBuffer2[x] = fileBuffer[x];
            }
            for (int x = (int)buffLoc; x < tFileBuffer2.Length; x++)
            {
                tFileBuffer2[x] = fileBuffer[x - lengthDiff];
            }
            fileBuffer = tFileBuffer2;
        }

        //updateString: saves a string to fileBuffer, allocating extra space and correcting all offsets if necessary.
        //oldLength is straight from the file buffer. newLength is the new string length without the null terminator.
        //index1 is nameLengthIndex1 from an animListItem, index2 is nameLengthIndex2 from an animListItem. These are
        //indices in the file buffer (minus two since they're tag locations) where the string's length should be recorded.
        private void updateString(uint oldLength, int newLength, uint index1, uint index2, string newString, uint buffLoc)
        {
            uint trueNameOffset = buffLoc * 4;
            uint oldLength16b = (uint)Math.Ceiling((float)oldLength / 16f);
            uint newLength16b = (uint)Math.Ceiling((float)(newLength + 1) / 16f);
            int lengthDiff = ((int)newLength16b - (int)oldLength16b) * 4; //16 bytes = 4 floats

            //Save length of name string, including null terminator
            fileBuffer[index1 + 2] = ToFloat((uint)newLength + 1u);
            fileBuffer[index2 + 2] = fileBuffer[index1 + 2];

            if (lengthDiff != 0)
            {
                fixAddresses(buffLoc, lengthDiff);
            }

            //Store string lss.animName + '\0' + as many 0xAAs as necessary to fill up to a 16 byte boundary.
            char[] chrName = newString.ToCharArray();
            char[] tChr = new char[4];
            for (int Z = 0; Z < newLength16b * 4; Z++)
            {
                tChr[0] = 'ª'; tChr[1] = 'ª'; tChr[2] = 'ª'; tChr[3] = 'ª';

                for (int x = 0; x < 4; x++)
                {
                    if (chrName.Length == Z * 4 + x)
                    { //Length == index, so this is the first byte after the non-null-terminated string.
                        tChr[x] = '\0';
                    }
                    else if (chrName.Length > Z * 4 + x)
                    {
                        tChr[x] = chrName[Z * 4 + x];
                    }
                }

                fileBuffer[buffLoc + Z] = ToFloat((uint)(tChr[0] + (int)tChr[1] * 0x100 + (int)tChr[2] * 0x10000 + (int)tChr[3] * 0x1000000));
            }

        }

        private void lstAnimNames_SelectedIndexChanged(object sender, EventArgs e)
        {
            nanoTimerB.Enabled = false;
            nanoTimerB.Enabled = true;

            saveAnim();
        }

        private void nanoTimerB_Tick(object sender, EventArgs e)
        {
            nanoTimerB.Enabled = false;
            lastSelectedAnim = lstAnimNames.SelectedIndex;
            if (lastSelectedAnim == -1)
            {
                for (int x = 0; x < 8; x++) cbBox[x].Visible = false;
                return;
            }
            ignoreCbBoxChange = true;

            //Read newly selected item's data
            string[] tStrs = ((animListItem)lstAnimNames.SelectedItem).animName.Split(' ');
            int nextBox = 0;
            bool badName = false;

            for (int x = 0; x < tStrs.Length; x++)
            {
                for (int y = 0; y < cbBoxTemplate.Items.Count; y++)
                {
                    if ((string)cbBoxTemplate.Items[y] == tStrs[x]) {
                        cbBox[nextBox].SelectedIndex = y;
                        cbBox[nextBox].Visible = true;
                        nextBox++;
                        break;
                    }
                    if (y == cbBoxTemplate.Items.Count - 1) badName = true;
                }
            }

            cbBox[nextBox].SelectedIndex = 0;
            cbBox[nextBox].Visible = true;
            ignoreCbBoxChange = false;

            for (int x = nextBox + 1; x < 8; x++)
            {
                cbBox[x].Visible = false;
            }

            if (nextBox == 0 || badName) MessageBox.Show("The name of this animation sequence makes it unusable in-game. You should change its name.");
        }

        private void cbBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ignoreCbBoxChange) return;
            ignoreCbBoxChange = true;

            bool startDisappearing = false;
            for (int x = 0; x < 8; x++)
            {
                if (sender == cbBox[x])
                {
                    if (cbBox[x].SelectedIndex == 0)
                    {
                        startDisappearing = true;
                    }
                    else //Show next box
                    {
                        if (x < 7)
                        {
                            cbBox[x + 1].Visible = true;
                            cbBox[x + 1].SelectedIndex = 0;
                        }
                    }
                }
                else if (startDisappearing)
                {
                    cbBox[x].Visible = false;
                    cbBox[x].SelectedIndex = 0;
                }
            }

            string tStr = (string)cbBox[0].SelectedItem;
            for (int x = 1; x < 8; x++)
            {
                if (cbBox[x].SelectedIndex != 0)
                {
                    tStr += " " + (string)cbBox[x].SelectedItem;
                }
                else break;
            }
            ((animListItem)lstAnimNames.SelectedItem).animName = tStr;
            ignoreCbBoxChange = false;
        }

        private void autoRotateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            autoRotateChecked = autoRotateToolStripMenuItem.Checked;
        }

        private void showXYZToolStripMenuItem_Click(object sender, EventArgs e)
        {
            drawXYZChecked = showXYZToolStripMenuItem.Checked;
        }

        private void animationNamesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            commitAllChanges();
            showEditor(ANIMATIONS);
        }

        private void vertcesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            commitAllChanges();
            showEditor(VERTICES);
        }

        private void refPointsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //TODO
            commitAllChanges();
        }

        private void materialsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            commitAllChanges();
            showEditor(MATERIALS);
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = curDir;
            DialogResult wasOK = openFileDialog1.ShowDialog();
            if (openFileDialog1.FileName == "" || System.IO.File.Exists(openFileDialog1.FileName) == false || wasOK == DialogResult.Cancel)
            {
                return;
            }

            theFile = openFileDialog1.FileName.Replace('\\', '/');
            curDir = theFile.Substring(0, theFile.LastIndexOf('/'));

            startWork("Loading...");

            try
            {
                FileStream tFile = File.Open(theFile, FileMode.Open, FileAccess.Read);
                BinaryReader binR = new BinaryReader(tFile);
                fileBuffer = new float[tFile.Length / 4];
                for (uint x = 0; x < (uint)(tFile.Length / 4); x++)
                {
                    fileBuffer[x] = binR.ReadSingle();
                }
                binR.Close();

                createList();
                getAnims();
                getMaterials();
                setupVBuff(dxDev);

                editToolStripMenuItem.Enabled = true;
                optionsToolStripMenuItem.Enabled = true;
                saveToolStripMenuItem.Enabled = true;
                saveAsToolStripMenuItem.Enabled = true;
            }
            catch (IOException ioe)
            {
                MessageBox.Show(ioe.Message);
            }
            finally
            {
                endWork("Ready");
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            commitAllChanges();
            try
            {
                FileStream tFile = File.Open(theFile, FileMode.Create, FileAccess.Write);
                BinaryWriter binW = new BinaryWriter(tFile);

                for (uint x = 0; x < fileBuffer.Length; x++)
                {
                    binW.Write(fileBuffer[x]);
                }
                binW.Close();
            }
            catch (IOException ioe)
            {
                MessageBox.Show(ioe.Message);
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory = curDir;
            DialogResult svRes = saveFileDialog1.ShowDialog();
            if (svRes == DialogResult.Cancel) return;

            theFile = saveFileDialog1.FileName.Replace('\\', '/');
            curDir = theFile.Substring(0, theFile.LastIndexOf('/'));
            saveToolStripMenuItem_Click(sender, e);
        }

        private void renderFacesWIPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            renderFacesChecked = renderFacesWIPToolStripMenuItem.Checked;
            setupVBuff(dxDev);
        }

        private void lstMaterials_SelectedIndexChanged(object sender, EventArgs e)
        {
            nanoTimerMaterials.Enabled = false;
            nanoTimerMaterials.Enabled = true;

            saveMaterials();
        }

        private void saveMaterials()
        {
            if (lastSelectedMat == -1 || materialsSaving) return;
            materialsSaving = true;
            matListItem lss = (matListItem)lstMaterials.Items[lastSelectedMat];
            
            updateString(FromFloat(fileBuffer[lss.nameLengthIndex1]), lss.matName.Length, lss.nameLengthIndex1 - 2, lss.nameLengthIndex2, lss.matName, lss.buffLoc);
            try
            {
                fileBuffer[lss.specularMultIndex] = float.Parse(txtSpecularMult.Text);
            }
            catch (Exception e)
            {
                MessageBox.Show("The specular multiplier is invalid: " + e);
            }
            try
            {
                fileBuffer[lss.emissiveMultIndex] = float.Parse(txtEmissiveMult.Text);
            }
            catch (Exception e)
            {
                MessageBox.Show("The emissive multiplier is invalid: " + e);
            }
            
            lstMaterials.Items.RemoveAt(lastSelectedMat);
            lstMaterials.Items.Insert(lastSelectedMat, lss);
            materialsSaving = false;
        }

        private void getMaterials()
        {
            lastSelectedMat = -1;
            if (fileBuffer == null) return;
            uint X;
            //Get tags' start offset
            uint startOffset = FromFloat(fileBuffer[1]) / 4;

            for (X = startOffset; X < fileBuffer.Length; X += 4) //All tags are 32 bytes, so X += 4 (times 4 bytes per float)
            {
                if (FromFloat(fileBuffer[X]) == 0x4D41545Fu) //Find "_TAM" (in file, or MAT_ in memory), which is the materials tag's ID
                {
                    uint matsStart = FromFloat(fileBuffer[X + 1]) / 4;
                    uint matsCount = FromFloat(fileBuffer[X + 2]);

                    lstMaterials.BeginUpdate();
                    lstMaterials.Items.Clear();

                    //get all materials
                    for (uint Y = 0; Y < matsCount; Y++)
                    {
                        uint tIdx = matsStart + Y * 67; //0x10C (268) bytes

                        //fileBuffer[tIdx] is the length of the string. The length is ALSO located at tagIndex + 2.
                        uint tagIndex = startOffset + 4 * FromFloat(fileBuffer[tIdx + 1]); //fileBuffer[tIdx+1] is the tag index
                        uint nameStringOffset = FromFloat(fileBuffer[tagIndex + 1]) / 4; //Offset pointing to the actual string

                        string tStr = "";
                        for (uint Z = 0; Z < Math.Ceiling((double)FromFloat(fileBuffer[tagIndex + 2]) / 4.0); Z++)
                        {
                            //Get string
                            tStr += (char)(FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFFu);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF00u) / 0x100u);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF0000u) / 0x10000u);
                            tStr += (char)((FromFloat(fileBuffer[nameStringOffset + Z]) & 0xFF000000u) / 0x1000000u);
                        }
                        
                        tStr = tStr.Substring(0, tStr.IndexOf('\0'));

                        lstMaterials.Items.Add(new matListItem(tIdx, tagIndex, nameStringOffset, tStr));
                    }

                    lstMaterials.EndUpdate();
                }
            }
        }

        private void nanoTimerMaterials_Tick(object sender, EventArgs e)
        {
            nanoTimerMaterials.Enabled = false;
            lastSelectedMat = lstMaterials.SelectedIndex;
            if (lastSelectedMat == -1) return;

            //Read newly selected item's data
            txtMaterialName.Text = ((matListItem)lstMaterials.SelectedItem).matName;
            txtSpecularMult.Text = fileBuffer[((matListItem)lstMaterials.SelectedItem).specularMultIndex].ToString();
            txtEmissiveMult.Text = fileBuffer[((matListItem)lstMaterials.SelectedItem).emissiveMultIndex].ToString();
            //TODO: There's so much more to add!
        }

        void txtMaterialName_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (lastSelectedMat == -1) return;
            ((matListItem)lstMaterials.Items[lastSelectedMat]).matName = txtMaterialName.Text;
        }

        private void aBoutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Version " + Application.ProductVersion + ". Made by DeProgrammer.\n\nLast updated " + lastDate.ToLongDateString());
        }

        private void scaleEntireModelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            uint tBuffLoc;
            Form2 tDlg = new Form2();
            tDlg.ShowDialog();

            if (tDlg.DialogResult == DialogResult.Cancel) return;

            startWork("Scaling vertices...");

            lstVertices.BeginUpdate();
            for (int x = 0; x < lstVertices.Items.Count; x++)
            {
                tBuffLoc = ((uintTagListItem)lstVertices.Items[x]).buffLocTag;
                //Scale the values in memory
                fileBuffer[tBuffLoc] *= tDlg.resX;
                fileBuffer[tBuffLoc + 1] *= tDlg.resY;
                fileBuffer[tBuffLoc + 2] *= tDlg.resZ;

                //Update the item text
                lstVertices.Items[x].SubItems[0].Text = getCoordString(tBuffLoc);
                lstVertices.Items[x].SubItems[1].Text = getCoordString(tBuffLoc + 1);
                lstVertices.Items[x].SubItems[2].Text = getCoordString(tBuffLoc + 2);
            }

            lstVertices.EndUpdate();
            nanoTimer.Enabled = true; //Update text boxes for the selected item
            setupVBuff(dxDev);
            endWork("Ready");
        }
    }
}
